//
//  LoadingScene.m
//  ScenesAndLayers_Cocos2D
//
//  Created by Du Yabo on 11-12-8.
//  Copyright 2011年 Beijing Mobroad Tech Co.Ltd. All rights reserved.
//

#import "LoadingScene.h"
#import "FirstScene.h"
#import "SecondScene.h"
#import "MultiLayerScene.h"
#import "ParallaxScene.h"

@implementation LoadingScene

+(id) sceneWithTargetScene:(TargetScenes)targetScene
{
    return [[[self alloc] initWithTargetScene:targetScene] autorelease];
}

-(id) initWithTargetScene:(TargetScenes)targetScene
{
    if(self=[super init]){
        _targetScene=targetScene;
        
        CCLabelTTF *label=[CCLabelTTF labelWithString:@"Loading..." fontName:@"Marker Felt" fontSize:62];
        CGSize size=[[CCDirector sharedDirector] winSize];
        label.position=CGPointMake(size.width/2, size.height/2);
        label.color=ccYELLOW;
        [self addChild:label];
        
        //为了实现在一帧后执行场景切换，使用帧循环技术来完成此功能。在帧循环第一次更新时直接取消循环即可实现
        [self scheduleUpdate];
    }
    return self;
}

-(void) update:(ccTime)delta
{
    //取消注册在当前场景上的动作，即此帧循环方法仅执行一次
    [self unscheduleAllSelectors];
    
    switch (_targetScene) {
        case TargetSceneFirstScene:
            [[CCDirector sharedDirector] replaceScene:[FirstScene scene]];
            break;
        case TargetSceneSecondScene:
            [[CCDirector sharedDirector] replaceScene:[SecondScene scene]];
            break;
        case TargetSceneMultiLayerScene:
        {
            CCTransitionFade *transition=[CCTransitionFade transitionWithDuration:3 scene:[MultiLayerScene scene] withColor:ccWHITE];
            [[CCDirector sharedDirector] replaceScene:transition];
            break;
        }
        case TargetSceneParallaxScene:
        {
            CCTransitionFade *transition=[CCTransitionFade transitionWithDuration:3 scene:[ParallaxScene scene] withColor:ccWHITE];
            [[CCDirector sharedDirector] replaceScene:transition];
            break;
        }
        default:
            break;
    }
}

@end
