//
//  MultiLayerScene.h
//  ScenesAndLayers_Cocos2D
//
//  Created by Du Yabo on 11-12-8.
//  Copyright 2011年 Beijing Mobroad Tech Co.Ltd. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "cocos2d.h"

//如果头文件引入一个类仅是为了定义属性或方法的返回值
@class GameLayer;
@class UserInterfaceLayer;

//层标识枚举
typedef enum {
    LayerTagColorLayer,
    LayerTagGameLayer,
    LayerTagUILayer
} MultiLayerSceneTags;

//层动作标识枚举
typedef enum {
    ActionTagGameLayerMovesBack,
    ActionTagGameLayerRotates
} MultiLayerSceneActionTags;

//层Z-Index标识,由小到大来决定渲染顺序
typedef enum {
    ZIndexTagColorLayer,
    ZIndexTagGameLayer,
    ZIndexTagUILayer
} MultiLayerSceneZIndexTags;

@interface MultiLayerScene : CCLayer {
    bool isTouchForUserInterface;
}

+(MultiLayerScene*) sharedLayer;
+(id) scene;

@property (readonly) GameLayer *gameLayer;
@property (readonly) UserInterfaceLayer *uiLayer;

+(CGPoint) locationFromTouch:(UITouch*)touch;
+(CGPoint) locationFromTouches:(NSSet *)touches;

@end
