//
//  MultiLayerScene.m
//  ScenesAndLayers_Cocos2D
//
//  Created by Du Yabo on 11-12-8.
//  Copyright 2011年 Beijing Mobroad Tech Co.Ltd. All rights reserved.
//

#import "MultiLayerScene.h"
#import "GameLayer.h"
#import "UserInterfaceLayer.h"
#import "ColorLayer.h"

@implementation MultiLayerScene

static MultiLayerScene *multiLayerSceneInstance;

+(id) scene
{
    CCScene *scene=[CCScene node];
    MultiLayerScene *layer=[MultiLayerScene node];
    [scene addChild:layer];
    return scene;
}

-(id) init
{
    if(self=[super init]){
        multiLayerSceneInstance=self;
        
        //背景层，功能与glClearColor(1, 0, 1, 1)相同
        ColorLayer *colorLayer=[ColorLayer layerWithColor:ccc4(255, 0, 255, 255)];
        [self addChild:colorLayer z:ZIndexTagColorLayer tag:LayerTagColorLayer];
        
        GameLayer *gameLayer=[GameLayer node];
        [self addChild:gameLayer z:ZIndexTagGameLayer tag:LayerTagGameLayer];
        
        UserInterfaceLayer *uiLayer=[UserInterfaceLayer node];
        [self addChild:uiLayer z:ZIndexTagUILayer tag:LayerTagGameLayer];
    }
    return self;
}

+(MultiLayerScene*) sharedLayer
{
    return multiLayerSceneInstance;
}

//实现@property所定义的变量的GET方法
-(GameLayer*) gameLayer
{
    CCNode *node=[[MultiLayerScene sharedLayer] getChildByTag:LayerTagGameLayer];
    return (GameLayer*)node;
}

-(UserInterfaceLayer*) uiLayer
{
    CCNode *node=[[MultiLayerScene sharedLayer] getChildByTag:LayerTagUILayer];
    return (UserInterfaceLayer*)node;
}

+(CGPoint) locationFromTouch:(UITouch*)touch
{
    CGPoint location=[touch locationInView:[touch view]];
    return [[CCDirector sharedDirector] convertToGL:location];
}

+(CGPoint) locationFromTouches:(NSSet *)touches
{
    return [self locationFromTouches:[touches anyObject]];
}

-(void) dealloc
{
    [multiLayerSceneInstance release];
    multiLayerSceneInstance=nil;
    
    [super dealloc];
}


@end
